#ifndef _H_F516F2E018EFCED88444AD0AF5560DB9_Gpgga_DCPS_H_
#define _H_F516F2E018EFCED88444AD0AF5560DB9_Gpgga_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Gpgga_.h"


namespace nmea_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Gpgga_TypeSupportInterface;

            typedef Gpgga_TypeSupportInterface * Gpgga_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Gpgga_TypeSupportInterface> Gpgga_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Gpgga_TypeSupportInterface> Gpgga_TypeSupportInterface_out;


            class Gpgga_DataWriter;

            typedef Gpgga_DataWriter * Gpgga_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Gpgga_DataWriter> Gpgga_DataWriter_var;
            typedef DDS_DCPSInterface_out < Gpgga_DataWriter> Gpgga_DataWriter_out;


            class Gpgga_DataReader;

            typedef Gpgga_DataReader * Gpgga_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Gpgga_DataReader> Gpgga_DataReader_var;
            typedef DDS_DCPSInterface_out < Gpgga_DataReader> Gpgga_DataReader_out;


            class Gpgga_DataReaderView;

            typedef Gpgga_DataReaderView * Gpgga_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Gpgga_DataReaderView> Gpgga_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Gpgga_DataReaderView> Gpgga_DataReaderView_out;

            struct Gpgga_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Gpgga_, struct Gpgga_Seq_uniq_> Gpgga_Seq;
            typedef DDS_DCPSSequence_var < Gpgga_Seq> Gpgga_Seq_var;
            typedef DDS_DCPSSequence_out < Gpgga_Seq> Gpgga_Seq_out;

            class  Gpgga_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Gpgga_TypeSupportInterface_ptr _ptr_type;
                typedef Gpgga_TypeSupportInterface_var _var_type;

                static Gpgga_TypeSupportInterface_ptr _duplicate (Gpgga_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gpgga_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Gpgga_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gpgga_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Gpgga_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Gpgga_TypeSupportInterface () {};
                ~Gpgga_TypeSupportInterface () {};
            private:
                Gpgga_TypeSupportInterface (const Gpgga_TypeSupportInterface &);
                Gpgga_TypeSupportInterface & operator = (const Gpgga_TypeSupportInterface &);
            };

            class  Gpgga_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Gpgga_DataWriter_ptr _ptr_type;
                typedef Gpgga_DataWriter_var _var_type;

                static Gpgga_DataWriter_ptr _duplicate (Gpgga_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gpgga_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Gpgga_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gpgga_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Gpgga_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Gpgga_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Gpgga_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Gpgga_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Gpgga_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Gpgga_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Gpgga_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Gpgga_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Gpgga_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Gpgga_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Gpgga_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Gpgga_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Gpgga_& instance_data) = 0;

            protected:
                Gpgga_DataWriter () {};
                ~Gpgga_DataWriter () {};
            private:
                Gpgga_DataWriter (const Gpgga_DataWriter &);
                Gpgga_DataWriter & operator = (const Gpgga_DataWriter &);
            };

            class  Gpgga_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Gpgga_DataReader_ptr _ptr_type;
                typedef Gpgga_DataReader_var _var_type;

                static Gpgga_DataReader_ptr _duplicate (Gpgga_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gpgga_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Gpgga_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gpgga_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Gpgga_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Gpgga_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Gpgga_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Gpgga_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Gpgga_& instance) = 0;

            protected:
                Gpgga_DataReader () {};
                ~Gpgga_DataReader () {};
            private:
                Gpgga_DataReader (const Gpgga_DataReader &);
                Gpgga_DataReader & operator = (const Gpgga_DataReader &);
            };

            class  Gpgga_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Gpgga_DataReaderView_ptr _ptr_type;
                typedef Gpgga_DataReaderView_var _var_type;

                static Gpgga_DataReaderView_ptr _duplicate (Gpgga_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gpgga_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Gpgga_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gpgga_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Gpgga_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Gpgga_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Gpgga_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Gpgga_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Gpgga_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Gpgga_& instance) = 0;

            protected:
                Gpgga_DataReaderView () {};
                ~Gpgga_DataReaderView () {};
            private:
                Gpgga_DataReaderView (const Gpgga_DataReaderView &);
                Gpgga_DataReaderView & operator = (const Gpgga_DataReaderView &);
            };
        }

    }

}

#endif
