#ifndef _H_537C18FDEE0B138773E455DC0C438DA6_Gpgsa_DCPS_H_
#define _H_537C18FDEE0B138773E455DC0C438DA6_Gpgsa_DCPS_H_

#include "sacpp_mapping.h"
#include "dds_dcps.h"
#include "Gpgsa_.h"


namespace nmea_msgs
{
    namespace msg
    {
        namespace dds_
        {
            class Gpgsa_TypeSupportInterface;

            typedef Gpgsa_TypeSupportInterface * Gpgsa_TypeSupportInterface_ptr;
            typedef DDS_DCPSInterface_var < Gpgsa_TypeSupportInterface> Gpgsa_TypeSupportInterface_var;
            typedef DDS_DCPSInterface_out < Gpgsa_TypeSupportInterface> Gpgsa_TypeSupportInterface_out;


            class Gpgsa_DataWriter;

            typedef Gpgsa_DataWriter * Gpgsa_DataWriter_ptr;
            typedef DDS_DCPSInterface_var < Gpgsa_DataWriter> Gpgsa_DataWriter_var;
            typedef DDS_DCPSInterface_out < Gpgsa_DataWriter> Gpgsa_DataWriter_out;


            class Gpgsa_DataReader;

            typedef Gpgsa_DataReader * Gpgsa_DataReader_ptr;
            typedef DDS_DCPSInterface_var < Gpgsa_DataReader> Gpgsa_DataReader_var;
            typedef DDS_DCPSInterface_out < Gpgsa_DataReader> Gpgsa_DataReader_out;


            class Gpgsa_DataReaderView;

            typedef Gpgsa_DataReaderView * Gpgsa_DataReaderView_ptr;
            typedef DDS_DCPSInterface_var < Gpgsa_DataReaderView> Gpgsa_DataReaderView_var;
            typedef DDS_DCPSInterface_out < Gpgsa_DataReaderView> Gpgsa_DataReaderView_out;

            struct Gpgsa_Seq_uniq_ {};
            typedef DDS_DCPSUVLSeq < Gpgsa_, struct Gpgsa_Seq_uniq_> Gpgsa_Seq;
            typedef DDS_DCPSSequence_var < Gpgsa_Seq> Gpgsa_Seq_var;
            typedef DDS_DCPSSequence_out < Gpgsa_Seq> Gpgsa_Seq_out;

            class  Gpgsa_TypeSupportInterface :
                virtual public DDS::TypeSupport
            { 
            public:
                typedef Gpgsa_TypeSupportInterface_ptr _ptr_type;
                typedef Gpgsa_TypeSupportInterface_var _var_type;

                static Gpgsa_TypeSupportInterface_ptr _duplicate (Gpgsa_TypeSupportInterface_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gpgsa_TypeSupportInterface_ptr _narrow (DDS::Object_ptr obj);
                static Gpgsa_TypeSupportInterface_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gpgsa_TypeSupportInterface_ptr _nil () { return 0; }
                static const char * _local_id;
                Gpgsa_TypeSupportInterface_ptr _this () { return this; }


            protected:
                Gpgsa_TypeSupportInterface () {};
                ~Gpgsa_TypeSupportInterface () {};
            private:
                Gpgsa_TypeSupportInterface (const Gpgsa_TypeSupportInterface &);
                Gpgsa_TypeSupportInterface & operator = (const Gpgsa_TypeSupportInterface &);
            };

            class  Gpgsa_DataWriter :
                virtual public DDS::DataWriter
            { 
            public:
                typedef Gpgsa_DataWriter_ptr _ptr_type;
                typedef Gpgsa_DataWriter_var _var_type;

                static Gpgsa_DataWriter_ptr _duplicate (Gpgsa_DataWriter_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gpgsa_DataWriter_ptr _narrow (DDS::Object_ptr obj);
                static Gpgsa_DataWriter_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gpgsa_DataWriter_ptr _nil () { return 0; }
                static const char * _local_id;
                Gpgsa_DataWriter_ptr _this () { return this; }

                virtual DDS::LongLong register_instance (const Gpgsa_& instance_data) = 0;
                virtual DDS::LongLong register_instance_w_timestamp (const Gpgsa_& instance_data, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long unregister_instance (const Gpgsa_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long unregister_instance_w_timestamp (const Gpgsa_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long write (const Gpgsa_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long write_w_timestamp (const Gpgsa_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long dispose (const Gpgsa_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long dispose_w_timestamp (const Gpgsa_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long writedispose (const Gpgsa_& instance_data, DDS::LongLong handle) = 0;
                virtual DDS::Long writedispose_w_timestamp (const Gpgsa_& instance_data, DDS::LongLong handle, const DDS::Time_t& source_timestamp) = 0;
                virtual DDS::Long get_key_value (Gpgsa_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Gpgsa_& instance_data) = 0;

            protected:
                Gpgsa_DataWriter () {};
                ~Gpgsa_DataWriter () {};
            private:
                Gpgsa_DataWriter (const Gpgsa_DataWriter &);
                Gpgsa_DataWriter & operator = (const Gpgsa_DataWriter &);
            };

            class  Gpgsa_DataReader :
                virtual public DDS::DataReader
            { 
            public:
                typedef Gpgsa_DataReader_ptr _ptr_type;
                typedef Gpgsa_DataReader_var _var_type;

                static Gpgsa_DataReader_ptr _duplicate (Gpgsa_DataReader_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gpgsa_DataReader_ptr _narrow (DDS::Object_ptr obj);
                static Gpgsa_DataReader_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gpgsa_DataReader_ptr _nil () { return 0; }
                static const char * _local_id;
                Gpgsa_DataReader_ptr _this () { return this; }

                virtual DDS::Long read (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Gpgsa_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Gpgsa_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Gpgsa_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Gpgsa_& instance) = 0;

            protected:
                Gpgsa_DataReader () {};
                ~Gpgsa_DataReader () {};
            private:
                Gpgsa_DataReader (const Gpgsa_DataReader &);
                Gpgsa_DataReader & operator = (const Gpgsa_DataReader &);
            };

            class  Gpgsa_DataReaderView :
                virtual public DDS::DataReaderView
            { 
            public:
                typedef Gpgsa_DataReaderView_ptr _ptr_type;
                typedef Gpgsa_DataReaderView_var _var_type;

                static Gpgsa_DataReaderView_ptr _duplicate (Gpgsa_DataReaderView_ptr obj);
                DDS::Boolean _local_is_a (const char * id);

                static Gpgsa_DataReaderView_ptr _narrow (DDS::Object_ptr obj);
                static Gpgsa_DataReaderView_ptr _unchecked_narrow (DDS::Object_ptr obj);
                static Gpgsa_DataReaderView_ptr _nil () { return 0; }
                static const char * _local_id;
                Gpgsa_DataReaderView_ptr _this () { return this; }

                virtual DDS::Long read (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_w_condition (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_w_condition (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long read_next_sample (Gpgsa_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long take_next_sample (Gpgsa_& received_data, DDS::SampleInfo& sample_info) = 0;
                virtual DDS::Long read_instance (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_instance (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long take_next_instance (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ULong sample_states, DDS::ULong view_states, DDS::ULong instance_states) = 0;
                virtual DDS::Long read_next_instance_w_condition (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long take_next_instance_w_condition (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq, DDS::Long max_samples, DDS::LongLong a_handle, DDS::ReadCondition_ptr a_condition) = 0;
                virtual DDS::Long return_loan (Gpgsa_Seq& received_data, DDS::SampleInfoSeq& info_seq) = 0;
                virtual DDS::Long get_key_value (Gpgsa_& key_holder, DDS::LongLong handle) = 0;
                virtual DDS::LongLong lookup_instance (const Gpgsa_& instance) = 0;

            protected:
                Gpgsa_DataReaderView () {};
                ~Gpgsa_DataReaderView () {};
            private:
                Gpgsa_DataReaderView (const Gpgsa_DataReaderView &);
                Gpgsa_DataReaderView & operator = (const Gpgsa_DataReaderView &);
            };
        }

    }

}

#endif
